#!/bin/bash

# Main loop of Lora data logger
# This loop reads specific values from the battery as well as the solar charger and sends it via LoRa APRS

# Get file names of data logging files
json_bms_file=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/config.json -f liontron_bms_data_file)
json_solar_file=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/config.json -f epever_data_file)

while :
do
    # Get the remaining capacity from the battery
    remain_cap_percent=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/liontron_bms_data.json -f remain_cap_percent)

    total_voltage=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/liontron_bms_data.json -f total_voltage)

    power=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/liontron_bms_data.json -f power)

    ambient_temp=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/epever_data.json -f ambient_temp)

    # Is the SolarGenerator switched on or off?
    #load_on=$(/usr/bin/python /home/marcel/SolarGenerator/get_field_from_json.py -i /home/marcel/SolarGenerator/epever_data.json -f load_on)

    echo "Capacity=$remain_cap_percent"
    echo "Voltage=$total_voltage"
    echo "Power=$power"
    echo "Temperature=$ambient_temp"
    #echo "LOAD=$load_on"

    aprs_message=":PE1RXF-3 :$remain_cap_percent,$total_voltage,$power,$ambient_temp"
    echo "Sending APRS message: APZMD:$aprs_message"
    /usr/sbin/beacon -d "APZMDM" -s ax0 "$aprs_message"

    echo
    echo "Loop repeats every 600 seconds. Press [CTRL+C] to stop.."
    sleep 600

done
